/* c-irrlicht --- C bindings for Irrlicht Engine

   Copyright (C) 2019 Javier Sancho <jsf@jsancho.org>

   This file is part of c-irrlicht.

   c-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   c-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#ifndef __C_SCENE_MANAGER_H_INCLUDED__
#define __C_SCENE_MANAGER_H_INCLUDED__

#include "IAnimatedMeshSceneNode.h"
#include "ICameraSceneNode.h"
#include "vector3d.h"

typedef void irr_scene_IAnimatedMesh;
typedef void irr_scene_ISceneManager;
typedef void irr_scene_ISceneNode;

#ifdef __cplusplus
extern "C" {
#endif

  irr_scene_IAnimatedMeshSceneNode*
  irr_scene_ISceneManager_addAnimatedMeshSceneNode(irr_scene_ISceneManager* smgr,
                                                   irr_scene_IAnimatedMesh* mesh,
                                                   irr_scene_ISceneNode* parent,
                                                   int id,
                                                   irr_core_vector3df* position,
                                                   irr_core_vector3df* rotation,
                                                   irr_core_vector3df* scale,
                                                   int alsoAddIfMeshPointerZero);

  irr_scene_ICameraSceneNode*
  irr_scene_ISceneManager_addCameraSceneNode(irr_scene_ISceneManager* smgr,
                                             irr_scene_ISceneNode* parent,
                                             irr_core_vector3df* position,
                                             irr_core_vector3df* lookat,
                                             int id,
                                             int makeActive);

  void
  irr_scene_ISceneManager_drawAll(irr_scene_ISceneManager* smgr);

  irr_scene_IAnimatedMesh*
  irr_scene_ISceneManager_getMesh(irr_scene_ISceneManager* smgr,
                                  const char* filename);

#ifdef __cplusplus
}
#endif

#endif
